<?php

class ArhcConverter
{

    const copy = "/* High contrast style. (c) ArHc plugin by Ivan Aristov. Telegram/WhatsApp:+7986573911 */";

    const reColor = [
        [
            "name" => [
                "color"
            ],
            "value" => "#000"
        ],
        [
            "name" => [
                "background",
                "background-color"
            ],
            "value" => "#FFF"
        ],
        [
            "name" => [
                "border",
                "border-color"
            ],
            "value" => "#999",
            "mask" => [
                "/(\#\w{3,6})/m",
                "/(rgba\(.*\))/m",
                "/(hsl\(.*\))/m",
                "/(\S+)$/m"
            ]
        ]
    ];

    /**
     *
     * @param string $file
     *            имя файла
     * @param string $file2
     *            имя файла вывода
     * @param boolean $check
     *            проверить существование и не пересоздавать, если уже существует
     */
    public function create($file, $file2, $check)
    {
        if ($check && (file_exists($file2)))
            return;

        $s = file_get_contents($file);

        // $q=[];
        // preg_match_all("/\/\*([\s\S]*?)\*\//m", $s, $q);
        // print_r($q);

        $s = preg_replace("/\/\*([\s\S]*?)\*\//m", "", $s);
        $s2 = self::copy;

        $rules = [];
        // preg_match_all("/([\w\s\,\.\#\:\-\_\>\~\@\(\)]+){([\w\W\r\n]+?)}/m", $s, $rules);

        $rules = explode("}", $s);

        foreach ($rules as $rule) {
            $has_bgc = (strpos($rule, "background") >= 0) && (strpos($rule, "color") >= 0);

            $rule2 = str_replace([
                "\r",
                "\n"
            ], "", $rule);
            ;
            $lines = explode(";", $rule2);
            foreach ($lines as $l) {
                if (trim($l) == "")
                    continue;

                $parts = [];
                preg_match("/([a-zA-Z\-]+)\:([\S\s]*?)$/m", $l, $parts);

                list ($all, $name, $value) = $parts;
                $value = self::changeColor($name, $value);
                $value = self::changeFont($name, $value);

                $l2 = sprintf("%s:%s", $name, $value);

                $rule2 = str_replace($all, $l2, $rule2);

                /*
                 * if (strpos($rule, ".query")!==false && $name=="background"){
                 * print_r($parts);
                 * print_r($l2);
                 * print_r($all);
                 * print_r($rule);
                 * print_r($rule2);
                 * }
                 */
            }
            $s2 .= $rule2 . "}";
        }

        file_put_contents($file2, $s2);
    }

    private function changeFont($name, $val, $do_white = false)
    {
        $v = $val;
        $names = [

            "font-size"
        ];
        if (in_array($name, $names)) {
            $re = "/(\S+)(em|px|ex|pt)/";
            $num = [];
            preg_match($re, $v, $num);
            if (count($num) > 0) {
                $n = floatval($num[1]);
                switch ($num[2]) {
                    case "em":
                        if ($n < 1)
                            $num2 = "1";
                        break;
                    case "px":
                    case "pt":
                        if ($n < 10)
                            $n *= 1.5;
                        if ($n <= 16)
                            $n *= 1.2;
                        $num2 = strval($n);
                        break;
                    default:
                        $num2 = $num[1];
                }

                $v = str_replace($num[1], $num2, $v);
            }
        }
        return $v;
    }

    private function changeColor($name, $val, $do_white = false)
    {
        $p2 = $val;

        foreach (self::reColor as $set) {
            if (in_array($name, $set["name"])) {
                if (isset($set["mask"])) {
                    $p2 = preg_replace($set["mask"], $set["value"], $val);
                } else {
                    $p2 = $set["value"];
                }
            }
        }

        return $p2;
    }
}

